<template>
  <b-row id="metadataManagerButtonRowBottom">
    <span v-if="isUploading" class="processStatement">
      {{
        totalNumberOfCurrentlyProcessedFiles - numberOfCurrentlyProcessedFiles
      }}/{{ totalNumberOfCurrentlyProcessedFiles }}
    </span>
    <div
      id="metadataManagerButtonRowBottomContainer"
      :class="saveButtonDisabled ? 'buttondisabled' : ''"
    >
      <!-- Upload Progress Bar -->
      <b-col>
        <b-progress
          v-if="isUploading"
          class="metadataManagerButtonRowProgress"
          :value="progressStatus"
          max="100"
          show-progress
          animated
        />
      </b-col>

      <!-- Upload Button -->
      <b-col id="metadataManagerButtonCol" class="ms-2">
        <b-button
          v-if="!isGuest"
          id="metadataManagerButtonRowBottomSave"
          class="metadataManagerButtonRowBottomSave"
          variant="primary"
          :disabled="saveButtonDisabled"
          @click="
            isUploading
              ? undefined
              : !showDetail
                ? $emit('uploadPreparation')
                : $emit('update')
          "
        >
          <b-spinner v-show="isUploading" label="Spinning" />
          {{
            isUploading
              ? $t("page.resource.metadataManagerBtnSaving")
              : !showDetail
                ? $t("page.resource.metadataManagerBtnUpload")
                : $t("page.resource.metadataManagerBtnUpdate")
          }}
        </b-button>
      </b-col>
    </div>
  </b-row>
</template>

<script lang="ts">
import useProjectStore from "@/modules/project/store";

export default defineComponent({
  props: {
    isUploading: {
      required: true,
      type: Boolean,
    },
    numberOfCurrentlyProcessedFiles: {
      required: true,
      type: Number,
    },
    progressStatus: {
      required: true,
      type: Number,
    },
    showDetail: {
      required: true,
      type: Boolean,
    },
    saveButtonDisabled: {
      required: true,
      type: Boolean,
    },
    totalNumberOfCurrentlyProcessedFiles: {
      required: true,
      type: Number,
    },
  },
  setup() {
    const projectStore = useProjectStore();

    return { projectStore };
  },

  computed: {
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
  },
});
</script>

<style scoped>
#metadataManagerButtonRowBottom {
  position: absolute;
  bottom: 45px;
  width: 100%;
}
#metadataManagerButtonRowBottom
  :deep(#metadataManagerButtonRowBottomContainer) {
  display: inline-flex;
  position: absolute;
  right: 0px;
  width: auto;
  height: 33px;
}
#metadataManagerButtonRowBottom
  :deep(#metadataManagerButtonRowBottomContainer.buttondisabled) {
  cursor: not-allowed;
}
#metadataManagerButtonRowBottom
  :deep(.metadataManagerButtonRowBottomSave.disabled) {
  pointer-events: none;
}
#metadataManagerButtonRowBottom :deep(.metadataManagerButtonRowProgress) {
  width: 350px;
  margin-top: 13px;
}
#metadataManagerButtonRowBottom :deep(.processStatement) {
  position: absolute;
  top: 7px;
  left: 20px;
}
button :deep(span.spinner-border) {
  height: 15px;
  width: 15px;
  margin-right: 4px;
}
</style>
